Hierarchy Class Reference

This class is specialized in retrieving loggers by name and also maintaining the logger hierarchy. More...

Inheritance diagram for Hierarchy:

## Public Member Functions

| Hierarchy ()
| Create a new logger hierarchy. More...
| ~Hierarchy ()
void | addRef () const
void | releaseRef () const
void | addHierarchyEventListener (const spi::HierarchyEventListenerPtr &listener)
void | clear ()
| This call will clear all logger definitions from the internal hashtable. More...
void | emitNoAppenderWarning (const LoggerPtr &logger)
LoggerPtr | exists (const LogString &name)
| Check if the named logger exists in the hierarchy. More...
void | setThreshold (const LogString &levelStr)
| The string form of setThreshold. More...
void | setThreshold (const LevelPtr &l)
| Enable logging for logging requests with level `l` or higher. More...
void | fireAddAppenderEvent (const LoggerPtr &logger, const AppenderPtr &appender)
void | fireRemoveAppenderEvent (const LoggerPtr &logger, const AppenderPtr &appender)
const LevelPtr & | getThreshold () const
| Returns a Level representation of the `enable` state. More...
LoggerPtr | getLogger (const LogString &name)
| Return a new logger instance named as the first parameter using the default factory. More...
LoggerPtr | getLogger (const LogString &name, const spi::LoggerFactoryPtr &factory)
| Return a new logger instance named as the first parameter using `factory`. More...
LoggerList | getCurrentLoggers () const
| Returns all the currently defined loggers in this hierarchy as a LoggerList. More...
LoggerPtr | getRootLogger () const
| Get the root of this hierarchy. More...
bool | isDisabled (int level) const
| This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise. More...
void | resetConfiguration ()
| Reset all values contained in this hierarchy instance to their default. More...
void | shutdown ()
| Used by subclasses to add a renderer to the hierarchy passed as parameter. More...
virtual bool | isConfigured ()
virtual void | setConfigured (bool configured)
Public Member Functions inherited from LoggerRepository
virtual | ~LoggerRepository ()
virtual void | addHierarchyEventListener (const HierarchyEventListenerPtr &listener)=0
| Add a HierarchyEventListener event to the repository. More...
Public Member Functions inherited from Object
virtual const helpers::Class & | getClass () const
virtual | ~Object ()
virtual bool | instanceof (const Class &clazz) const =0
virtual const void * | cast (const Class &clazz) const =0
Public Member Functions inherited from ObjectImpl
| ObjectImpl ()
virtual | ~ObjectImpl ()

## Additional Inherited Members

Static Public Member Functions inherited from Object
static const helpers::Class & | getStaticClass ()
static const log4cxx::helpers::ClassRegistration & | registerClass ()
Protected Attributes inherited from ObjectImpl
unsigned int volatile | ref

## Detailed Description

This class is specialized in retrieving loggers by name and also maintaining the logger hierarchy.

The casual user does not have to deal with this class directly.

The structure of the logger hierarchy is maintained by the getLogger method. The hierarchy is such that children link to their parent but parents do not have any pointers to their children. Moreover, loggers can be instantiated in any order, in particular descendant before ancestor.

In case a descendant is created before a particular ancestor, then it creates a provision node for the ancestor and adds itself to the provision node. Other descendants of the same ancestor add themselves to the previously created provision node.

## Constructor & Destructor Documentation

## Hierarchy()

Hierarchy | ( |  | ) |

Create a new logger hierarchy.

## ~Hierarchy()

~Hierarchy | ( |  | ) |

## Member Function Documentation

## addHierarchyEventListener()

void addHierarchyEventListener | ( | const spi::HierarchyEventListenerPtr & | listener | ) |

## addRef()

void addRef | ( |  | ) | const

virtual

Reimplemented from ObjectImpl.

## clear()

void clear | ( |  | ) |

This call will clear all logger definitions from the internal hashtable.

Invoking this method will irrevocably mess up the logger hierarchy.

You should really know what you are doing before invoking this method.

## emitNoAppenderWarning()

void emitNoAppenderWarning | ( | const LoggerPtr & | logger | ) |

virtual

Implements LoggerRepository.

## exists()

LoggerPtr exists | ( | const LogString & | name | ) |

virtual

Check if the named logger exists in the hierarchy.

If so return its reference, otherwise returns `null`.

Parameters

  name | The name of the logger to search for.

Implements LoggerRepository.

## fireAddAppenderEvent()

void fireAddAppenderEvent | ( | const LoggerPtr & | logger,
|  | const AppenderPtr & | appender
| ) |  |

virtual

Implements LoggerRepository.

## fireRemoveAppenderEvent()

void fireRemoveAppenderEvent | ( | const LoggerPtr & | logger,
|  | const AppenderPtr & | appender
| ) |  |

## getCurrentLoggers()

LoggerList getCurrentLoggers | ( |  | ) | const

virtual

Returns all the currently defined loggers in this hierarchy as a LoggerList.

The root logger is not included in the returned LoggerList.

Implements LoggerRepository.

## getLogger() [1/2]

LoggerPtr getLogger | ( | const LogString & | name | ) |

virtual

Return a new logger instance named as the first parameter using the default factory.

If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated and then linked with its existing ancestors as well as children.

Parameters

  name | The name of the logger to retrieve.

Implements LoggerRepository.

## getLogger() [2/2]

LoggerPtr getLogger | ( | const LogString & | name,
|  | const spi::LoggerFactoryPtr & | factory
| ) |  |

virtual

Return a new logger instance named as the first parameter using `factory`.

If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated by the `factory` parameter and linked with its existing ancestors as well as children.

Parameters

  name | The name of the logger to retrieve.
  factory | The factory that will make the new logger instance.

Implements LoggerRepository.

## getRootLogger()

LoggerPtr getRootLogger | ( |  | ) | const

virtual

Get the root of this hierarchy.

Implements LoggerRepository.

## getThreshold()

const LevelPtr& getThreshold | ( |  | ) | const

virtual

Returns a Level representation of the `enable` state.

Implements LoggerRepository.

## isConfigured()

virtual bool isConfigured | ( |  | ) |

virtual

Implements LoggerRepository.

## isDisabled()

bool isDisabled | ( | int | level | ) | const

virtual

This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise.

See also the setThreshold method.

Implements LoggerRepository.

## releaseRef()

void releaseRef | ( |  | ) | const

virtual

Reimplemented from ObjectImpl.

## resetConfiguration()

void resetConfiguration | ( |  | ) |

virtual

Reset all values contained in this hierarchy instance to their default.

This removes all appenders from all categories, sets the level of all non-root categories to `null`, sets their additivity flag to `true` and sets the level of the root logger to DEBUG. Moreover, message disabling is set its default "off" value.

Existing categories are not removed. They are just reset.

This method should be used sparingly and with care as it will block all logging until it is completed.

Implements LoggerRepository.

## setConfigured()

virtual void setConfigured | ( | bool | configured | ) |

virtual

Implements LoggerRepository.

## setThreshold() [1/2]

void setThreshold | ( | const LogString & | levelStr | ) |

virtual

The string form of setThreshold.

Implements LoggerRepository.

## setThreshold() [2/2]

void setThreshold | ( | const LevelPtr & | l | ) |

virtual

Enable logging for logging requests with level `l` or higher.

By default all levels are enabled.

Parameters

  l | The minimum level for which logging requests are sent to their appenders.

Implements LoggerRepository.

## shutdown()

void shutdown | ( |  | ) |

virtual

Used by subclasses to add a renderer to the hierarchy passed as parameter.

Shutting down a hierarchy will safely close and remove all appenders in all categories including the root logger.

Some appenders such as SocketAppender and AsyncAppender need to be closed before the application exists. Otherwise, pending logging events might be lost.

The `shutdown` method is careful to close nested appenders before closing regular appenders. This is allows configurations where a regular appender is attached to a logger and again to a nested appender.

Implements LoggerRepository.

The documentation for this class was generated from the following file:

- hierarchy.h